<?php

/**
 * Класс аутентификации пользователя
 * Переопределим класс CUserIdentity под свои нужды
 *
 * @version 0.1 2010/09/01
 * @author webmaxx
 */
class UserIdentity extends CUserIdentity
{

    // Логин юзера
    public $login;

    // Пароль юзера
    public $password;

    // Имя юзера, используемое на сайте
    public $username;

    // Будем хранить ID юзера.
    protected $_id;

    /**
     * Переопределим конструктор.
     * Вместо username и password будем использовать login и password
     *
     * @version 0.1 2010/09/01
     * @since 0.1
     * @author webmaxx
     */
    public function __construct($login, $password)
    {
        $this->login    = $login;
        $this->password = $password;
    }

    /**
     * Данный метод вызывается один раз при аутентификации пользователя
     *
     * @version 0.1 2010/09/01
     * @since 0.1
     * @author webmaxx
     */
    public function authenticate()
    {
        // Производим стандартную аутентификацию
        $User = Users::model()->find(array(
            'condition' => 'LOWER(login)=:login',
            'params' => array(':login'=>strtolower($this->login)),
        ));

        if (($User === null) || (md5($this->password) !== $User->password)) {
            $this->errorCode = self::ERROR_USERNAME_INVALID;
        } else {
            // В качестве идентификатора будем использовать id, а не username,
            // как это определено по умолчанию. Обязательно нужно переопределить
            // метод getId(см. ниже).
            $this->_id = $User->id;

            // Далее username и login пригодятся в самом приложении
            $this->login    = $User->login;
            $this->username = $User->username;

            $this->errorCode = self::ERROR_NONE;
        }
        return !$this->errorCode;
    }

    /**
     * Переопределяем родительский метод
     * Будем возвращать ID юзера вместо username
     *
     * @return integer
     *
     * @version 0.1 2010/09/01
     * @since 0.1
     * @author webmaxx
     */
    public function getId()
    {
        return $this->_id;
    }

    /**
     * Переопределяем родительский метод
     * Будем возвращать имя юзера
     *
     * @return string
     *
     * @version 0.1 2010/09/01
     * @since 0.1
     * @author webmaxx
     */
    public function getName()
    {
        return $this->username;
    }

}
