<?php

/**
 * Объект юзера, доступный через Yii::app()->user
 *
 * @version 0.1 2010/09/01
 * @author webmaxx
 */
class WebUser extends CWebUser
{

    // Объект модели юзера
    private $_Model = null;

    /**
     * Метод возвращает логин юзера
     *
     * @version 0.1 2010/09/01
     * @since 0.1
     * @author webmaxx
     */
    public function getLogin()
    {
        if ($User = $this->getModel()) {
            return $User->login;
        }
    }

    /**
     * Метод возвращает username, используемый на сайте
     *
     * @version 0.1 2010/09/01
     * @since 0.1
     * @author webmaxx
     */
    public function getUsername()
    {
        if ($User = $this->getModel()) {
            return $User->username;
        }
    }

    /**
     * Метод возвращает роль юзера
     *
     * @version 0.1 2010/09/01
     * @since 0.1
     * @author webmaxx
     */
    public function getRole()
    {
        if ($User = $this->getModel()) {
            return $User->role;     // в таблице users есть поле role
        }
    }

    /***************************************************************************/
    /*                         Приватные методы                                */
    /***************************************************************************/

    /**
     * Метод возвращает создает и возвращает объект модели юзера
     *
     * @version 0.1 2010/09/01
     * @since 0.1
     * @author webmaxx
     */
    private function getModel()
    {
        if ($this->_Model === null) {
            $this->_Model = Users::model()->findByPk($this->id);
        }
        return $this->_Model;
    }

}

