<?php

return array(
    'basePath'          => dirname(__FILE__).DIRECTORY_SEPARATOR.'..',
    'name'              => 'test',
    'defaultController' => 'index',
    'language'          => 'ru',
    'sourceLanguage'    => 'ru',
    'theme'             => 'default',

    // Прелоад компонентов
    'preload' => array('log'),

    // Автозагрузка моделей, компонентов и вообще всего того, что надо загрузить автоматом.
    'import' => array(
        'application.models.*',
        'application.components.*',
        'application.widgets.*',
        'application.controllers.BaseController',   // Подключаем базовый контроллер
        //'application.extensions.yiidebugtb.*',      // Debug-панель. На продакшене отключать!!!
    ),

    // Подгружаем файл с параметрами приложения
    'params' => require_once dirname(__FILE__).DIRECTORY_SEPARATOR.'params.php',

    // Настройки компонентов приложения
    'components' => array(

        // Ведем логи
        'log' => array(
            'class'  => 'CLogRouter',
            'routes' => array(
                array(
                    'class'  => 'CFileLogRoute',
                    'levels' => 'error, warning',
                ),
            ),
        ),

        // Настройки подключения к БД
        'db' => array(
            'class'            => 'CDbConnection',
            'connectionString' => 'sqlite:protected/db/homebook.db',    // Строка коннекта к БД
            'tablePrefix'      => 'm_',     // Префикс таблиц БД
        ),

        // Настраиваем компонент юзверя
        'user' => array(
            'class'          => 'WebUser',
            'loginUrl'       => '/user/login',
            'allowAutoLogin' => true,   // Разрешаем/запрещаем автологин пользователя из куков
        ),

        // Настраиваем авторизацию и аутентификацию пользователя
        'authManager' => array(
            'class'        => 'PhpAuthManager',   // Будем использовать свой менеджер авторизации
            'defaultRoles' => array('guest'),     // Роль по умолчанию. Все, кто не авторизован — гости.
            'authFile'     => require_once dirname(__FILE__).DIRECTORY_SEPARATOR.'roles.php' // Файл с настройками ролей
        ),

        // Настраиваем урлы
        'urlManager'         => array(
            'urlFormat'      => 'path',
            'showScriptName' => false,
            'urlSuffix'      => '.html',
            'rules'          => require_once dirname(__FILE__).DIRECTORY_SEPARATOR.'urlRules.php', // Подгружаем файл с роутингами
        ),
        
        'errorHandler' => array(
            'errorAction' => 'error/index',
        ),

        // Делаем работу сессий через БД
        'session' => array(
            'class'            => 'CDbHttpSession',
            'connectionID'     => 'db',
            'sessionTableName' => 'm_sessions',
            'timeout'          => '1200',
        ),

    ),

    // Подключаем и настраиваем модули
    'modules' => array(
        
    ),

);
