<?php

/**
 * Базовый контроллер. Родитель всех остальных контроллеров.
 * Сюда надо писать то, что будет использоваться во всех потомках.
 *
 * @abstract
 * @version 0.1 2010/09/01
 * @author webmaxx
 */
abstract class BaseController extends CController
{

    // Заголовок страницы по умолчанию
    public $pageTitle = '';

    // Описание страницы
    public $metaDescription = '';

    // Ключевые слова страницы
    public $metaKeywords = '';

    // Шаблон-обертка по умолчанию
    public $layout = 'main';

    // Массив с различными данными, которые нужны на всех страницах сайта
    public $vars = array();

    // Текущая страница
    public $page = 1;

    // Аяксовый запрос или нет
    public $isAjax = false;

    /**
     * Создаем список фильтров
     *
     * @version 0.1 2010/09/01
     * @since 0.1
     * @author webmaxx
     */
    public function filters()
    {
        return array(
            'accessControl',
            /*
            array(
                'application.filters.XssFilter',
                'clean'=>'*',
            ),
            */
        );
    }

    /**
     * Метод возвращает массив с действиями
     *
     * @version 0.1 2010/09/01
     * @since 0.1
     * @author webmaxx
     */
    public function actions()
    {
        return array(
            'captcha'=>array(
                'class'=>'extensions.Captcha.MathCaptchaAction',
                'backColor'=>0xEBF4FB,
            ),
        );
    }

    /**
     * Правила доступа к страницам
     *
     * @version 0.1 2010/09/01
     * @since 0.1
     * @author webmaxx
     */
    public function accessRules()
    {
        return array();
    }

    /**
     * Настраиваем параметры по умолчанию, одинаковые во всех контроллерах
     *
     * @version 0.1 2010/09/01
     * @since 0.1
     * @author webmaxx
     */
    public function init()
    {
        // текущая страница
        $this->page = (isset($_GET['page']) && is_numeric($_GET['page']) && $_GET['page'] > 0) ? $_GET['page'] : 1;

        // Проверяем, аяксовый запрос или нет
        $this->isAjax = Yii::app()->request->isAjaxRequest ? true : false;

        // Определяем IP и Proxy юзера
        if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            $this->vars['user']['ip'] = $_SERVER['HTTP_X_FORWARDED_FOR'];
            $this->vars['user']['proxy'] = $_SERVER['REMOTE_ADDR'];
        } else {
            $this->vars['user']['ip'] = $_SERVER['REMOTE_ADDR'];
            $this->vars['user']['proxy'] = '';
        }
    }

    /***************************************************************************/
    /*                         Публичные методы                                */
    /***************************************************************************/

    /***************************************************************************/
    /*                         Приватные методы                                */
    /***************************************************************************/

    /***************************************************************************/
    /*                         Защищенные методы                               */
    /***************************************************************************/

    /***************************************************************************/
    /*                             Фильтры                                     */
    /***************************************************************************/
    
}

